# Conditionals Exercises

This series of exercises helps you build confidence using conditionals in Python:
from basic `if` statements to `match-case` syntax introduced in Python 3.10.

---

## Covered Topics

| Exercise           | Concept                                      |
|--------------------|----------------------------------------------|
| `conditionals1.py` | Basic `if` statements and comparison operators (`==`, `!=`, `<`, etc.) |
| `conditionals2.py` | `if-elif-else` chains                        |
| `conditionals3.py` | Compound conditions and nested `if` blocks   |
| `conditionals4.py` | `match-case` statements (structural matching)|
| `conditionals5.py` | Ternary expressions and Elvis-operator-like logic |

---

## How to Use

Each file contains:
- One or more function stubs with `TODO` instructions
- `assert`-based tests that guide and validate your implementation

Look for output that says `All tests passed!` or helpful `[FAIL]` messages.

---

## Tips
- Be mindful of indentation and logical grouping in nested `if` statements
- Use `match-case` only if you're running Python 3.10+
- Conditional expressions (`x if condition else y`) are great for simple logic

---

## Coming Soon
- Logical operators (`and`, `or`, `not`) in deeper combinations
- Pattern matching with types and data classes

---

Happy branching!