# Loops Exercises

This section of exercises introduces Python loops, including both `for` and `while` loops. You'll also combine loops with conditional logic to create more powerful patterns.

---

## Covered Topics

| Exercise        | Concept                                                   |
|----------------|------------------------------------------------------------|
| `loops1.py`     | `for` loops, `while` loops, and conditionals inside loops |

---

## How to Use

Each file includes:
- Function stubs marked with `TODO` for you to complete
- Built-in test cases using `assert` statements

You should see printed results and no errors if everything is correct.

---

## Tips
- Use `range(start, stop)` in `for` loops to generate number sequences
- `while` loops require manual incrementing — avoid infinite loops!
- You can combine `if` inside a loop to filter items (e.g. collect evens)

---

## Coming Soon
Future exercises will include:
- Nested loops
- Loop control (`break`, `continue`)
- Looping over collections and dictionaries

---

Happy looping!