# Quiz: Library System

This quiz challenges you to build a basic object-oriented system combining core concepts you've learned so far:

- Class definition and attributes
- Methods (including `__init__`, `__str__`)
- Conditionals
- Lists and loops

---

## Scenario
You're tasked with creating a mini Library Management System. It should track books, allow borrowing and returning, and display the current library catalog.

---

## Learning Objectives
- Define classes with multiple attributes
- Use boolean flags and conditionals for state control
- Iterate over lists of objects to search and act
- Use `__str__` for clean output formatting

---

## Files

| File        | Purpose                                   |
|-------------|-------------------------------------------|
| `quiz1.py`  | Build the `Book` and `Library` classes    |

---

## Test Cases
Your code will be tested for:
- Creating and displaying books
- Borrowing books only if available
- Returning books
- Clean output using `__str__`

Expected output should include book details and a passing set of asserts.

Good luck!