# Variables Exercises

This section introduces Python variables and how to work with them in different contexts — from simple assignments to numeric operations, string manipulation, and slicing. Each exercise is focused on foundational variable skills essential for early learners.

---

## Covered Topics

| Exercise           | Concept                                                   |
|--------------------|-----------------------------------------------------------|
| `variables1.py`     | Variable types: strings, integers, floats, booleans      |
| `variables2.py`     | Using variables in temperature conversion formulas       |
| `variables3.py`     | String concatenation, f-strings, `.format()`, repetition |
| `variables4.py`     | Arithmetic, scaling, and visual representation with strings |
| `variables5.py`     | String indexing and slicing using a DNA sequence         |

---

## How to Use

Each file includes:
- Clear `TODO` tasks for variable manipulation
- Built-in `assert` tests to validate correctness

You should see printed values if all assertions pass. If not, helpful failure messages will point to what needs fixing.

---

## Tips
- Always pay attention to the data type a variable is supposed to hold
- Use `+` to concatenate strings or `*` to repeat them
- You can slice strings using `[start:end]` and index them using `[index]`
- String slicing and indexing is 0-based (starts from position 0)

---

Understand variables deeply — they’re the building blocks of every program.