# Data Structures Exercises

These exercises introduce Python’s core data structures — lists, tuples, dictionaries, and sets — using real-world and relatable examples. You'll practice creation, access, mutation, and key operations unique to each structure.

---

## Covered Topics

| Exercise                 | Concept                                |
|--------------------------|----------------------------------------|
| `data_structures1.py`    | Lists: creation, indexing, append, insert, pop, remove |
| `data_structures2.py`    | Tuples: immutability, indexing, tuple operations       |
| `data_structures3.py`    | Dictionaries: nested values, access, add, remove, update |
| `data_structures4.py`    | Sets: deduplication, add/remove, set operations        |

---

## How to Use

Each exercise file contains:
- A short explanation of the data structure
- `TODO` blocks for you to complete
- Test assertions to validate your code

You’ll see printed output or failure messages guiding what to fix.

---

## Tips
- Lists are ordered and mutable — use indexing to access or modify items
- Tuples are immutable — create new ones to simulate updates
- Dictionaries map keys to values — perfect for structured, named data
- Sets help eliminate duplicates and support set theory operations

---

Master these structures — they are the foundation of Python programming! 🧱🐍